



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java程序员的日常 —— 多进程开发IO阻塞问题</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java程序员的日常 —— 多进程开发IO阻塞问题</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 07:03:21 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<blockquote><p>本篇仍旧是源于最近的工作，总结一下纪念那些年埋下的坑...</p></blockquote>
<h2>背景故事</h2>
<ul><li><p>需求：“使用进程方式启动另一个程序！”</p></li>
<li><p>开发：“OK! Runtime.getRuntime().exec(&quot;xxxx&quot;)”</p></li>
<li><p>需求：“启动以后能看到输出消息不！”</p></li>
<li><p>开发：“OK！”</p></li></ul>
<pre class="prettyprint linenums"><code>Process process = null;<br />
try {<br />
	process = Runtime.getRuntime().exec(&quot;ipconfig /all&quot;);<br />
} catch (IOException e) {<br />
	e.printStackTrace();<br />
}<br />
try {<br />
	String line;<br />
	InputStream is = process.getInputStream();<br />
	BufferedReader br = new BufferedReader(new InputStreamReader(is,&quot;GBK&quot;));

	while(null != (line = br.readLine())){<br />
		System.out.println(line);<br />
	}<br />
	System.out.println(&quot;---------------------------------------------------------------------------------------&quot;);<br />
	InputStream is_error = process.getErrorStream();<br />
	BufferedReader br_error = new BufferedReader(new InputStreamReader(is_error,&quot;GBK&quot;));

	while(null != (line = br_error.readLine())){<br />
		System.out.println(line);<br />
	}<br />
} catch (IOException e) {<br />
	e.printStackTrace();<br />
}<br />
</code></pre>
<p>于是，神坑挖好了！</p>
<h2>遇到的问题</h2>
<p>由于运行的程序比较复杂，有可能出现错误输出。这时就不好保证是错误输出还是标准输出哪个先到。但是上面的程序中，使用了同步的方式输出子进程的消息，结果就导致了子进程阻塞。</p>
<h2>解决方案1：使用缓冲区缓存消息</h2>
<p><a href="http://blog.csdn.net/dancen/article/details/7969328" rel="external nofollow noreferrer">这个可以参考CSDN的帖子</a></p>
<h2>解决方案2：使用ProcessBuilder合并标准输出和错误</h2>
<p>仍然源自于上面的博客：</p>
<pre class="prettyprint linenums"><code>try{<br />
	String[] cmds = {&quot;ipconfig&quot;,&quot;/all&quot;};<br />
	ProcessBuilder builder = new ProcessBuilder(cmds);    

	//合并输出流和错误流<br />
	builder.redirectErrorStream(true);    

	//启动进程<br />
	Process process = builder.start();    

	//获得输出流<br />
	BufferedReader br = new BufferedReader(new InputStreamReader(process.getInputStream(),&quot;GBK&quot;));<br />
	String line = null;<br />
	while (null != (line = br.readLine())){<br />
		System.out.println(line);<br />
	}<br />
}catch(IOException e){<br />
	e.printStackTrace();<br />
}<br />
</code></pre>
<p>上面的代码中<code>builder.redirectErrorStream(true);</code>就可以帮助你把错误合并到标准输出里面。</p>
<p>于是，很好奇这个ProcessBuilder到底什么东东。</p>
<h2>阅读API —— 什么是ProcessBuilder</h2>
<p>ProcessBuilder用于创建操作系统进程，每个ProcessBuilder实例都管理一个进程属性集合。通过调用start()方法，可以通过这些属性创建出一个进程。start()方法可以被多次调用，来创建多个独立的进程。</p>
<p>每个builder管理着下面的进程属性：</p>
<h4>cmmand</h4>
<p>命令，比如{“ipcofig”,&quot;/all&quot;}</p>
<h4>environment</h4>
<p>环境变量，子进程会直接使用当前进程的环境变量。环境变量是独立的，因此可以被修改，但是不会影响其他的进程。</p>
<h4>directory</h4>
<p>工作目录，如果返回的是Null,说明当前目录使用的是系统变量user.dir所在的目录。</p>
<h4>redirectErrorStream属性</h4>
<p>默认是false。Flase意味着标准输出和标准错误是两个独立的流，可以通过Process.getInputStream()和Process.getErrorStream()方法获得。</p>
<p>如果这个值设置为true，那么标准错误将会合并到标准输出中，并且发往同一个目标地址（这种特性使得错误消息可以很方便的和输出消息一起管理），此时，如果你再想要单独获取错误输出流，就会得到null。</p>
<h4>线程安全</h4>
<p>注意这个类不是线程安全的，因此如果多个线程使用ProcessBuilder实例，并且修改属性，那么可能会造成冲突。因此需要在外面进行线程同步。</p>
<h4>启动</h4>
<p>可以简单的向下面这样启动一个进程：</p>
<pre class="prettyprint linenums"><code> Process p = new ProcessBuilder(&quot;myCommand&quot;, &quot;myArg&quot;).start();<br />
</code></pre>
<h4>样例</h4>
<p>下面是官方文档中给出的样例，样例中修改了工作目录以及环境变量，并且把标准错误和标准输出合并输出到日志文件中：</p>
<pre class="prettyprint linenums"><code> ProcessBuilder pb = new ProcessBuilder(&quot;myCommand&quot;, &quot;myArg1&quot;, &quot;myArg2&quot;);<br />
 Map&lt;String, String&gt; env = pb.environment();<br />
 env.put(&quot;VAR1&quot;, &quot;myValue&quot;);<br />
 env.remove(&quot;OTHERVAR&quot;);<br />
 env.put(&quot;VAR2&quot;, env.get(&quot;VAR1&quot;) + &quot;suffix&quot;);<br />
 pb.directory(new File(&quot;myDir&quot;));<br />
 File log = new File(&quot;log&quot;);<br />
 pb.redirectErrorStream(true);<br />
 pb.redirectOutput(Redirect.appendTo(log));<br />
 Process p = pb.start();<br />
 assert pb.redirectInput() == Redirect.PIPE;<br />
 assert pb.redirectOutput().file() == log;<br />
 assert p.getInputStream().read() == -1;<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvjm31q.html">设计模式之美：Behavioral Patterns（行为型模式）</a>
		</li>
						<li><a href="https://www.batexi.com/a/r93g07w8.html">&lbrack;android&rsqb;AndroidInject框架&mdash;&mdash;我的第一个android小型框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p6jzdq.html">JDBC之SqlHelper</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o0jll8.html">Deep Learning 12&lowbar;深度学习UFLDL教程：Sparse Coding&lowbar;exercise（斯坦福大学深度学习教程）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xrw508.html">Objective-C语言控制语句</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4ygw43q.html">HDU 5996：dingyeye loves stone（阶梯博弈）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdkjnd8.html">Android进阶之大话设计模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjyn649.html">ThinkPHP函数详解：A方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xlx3w9.html">初次使用nodejs的问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1xzk69.html">linux svn用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zzzv39.html">VC6  鼠标钩子 最简单样例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv17wz1q.html">Android破解学习之路（六）&mdash;&mdash;Android游戏 方块冒险 破解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj3nnx9.html">Material Design之CollapsingToolbarLayout使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj6kwpq.html">如何把Python脚本导出为exe程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mo6m48.html">JavaScript入门学习笔记（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1g3doq.html">反射的应用，jdbc封装</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e4jrkz9.html">sublime项目的添加删除</a>
		</li>
						<li><a href="https://www.batexi.com/a/90rwogm9.html">Linux 进程管理之四大名捕</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7e04rj9.html">java中的Serializable接口的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9021grmq.html">shell脚本编程之&OpenCurlyDoubleQuote;最简单的死循环&rdquo;【转】</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/m8z6rjnq.html">&amp;lt&semi;数据结构与算法&amp;gt&semi;之字符串，散列，布隆过滤器。</a>
			</li>
						<li><a href="https://www.batexi.com/a/495zmlm9.html">&period;net sharepoint文档库操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/rqlw5me8.html">&OpenCurlyDoubleQuote;ORA-01033&colon;ORACLE initialization or shutdown in progress&rdquo;错误的解决</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93337r9.html">关于MFC文本框输入内容的获取 与 设置文本框的内容</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jvvgl9.html">JBOSS内存参数详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvj3kzq.html">&lbrack;置顶&rsqb;PADS PCB功能使用技巧系列之NO&period;006- 如何实现OrCAD与PADS Layout同步？</a>
			</li>
						<li><a href="https://www.batexi.com/a/3904kno8.html">无法远程到2008R2的解决方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gzx2l8.html">形参是ofstream</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2gv3x8.html">java 上传POJO model jar</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2gvev8.html">PPC MPC85xx e500学习笔记</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
